// Expressillä tehty yksinkertainen feikkiserveri Angular -sovellukselle
// data on kovakoodattu tähän tiedostoon ja sitä voi vain hakea.
// Käynnistys: node server
// Näet tuotteet osoitteesta http://localhost:3000/products

const express = require('express');
const cors = require('cors'); // cross origin resource sharing.
const app = express();
// cors mahdollistaa resurssien jaon eri palvelimilta peräisin olevien sovellusten kesken.
app.use(cors()); //cors käyttöönotto

// koska tietokantaa ei ole, ovat tuotteet tässä
const products = [{
    'id': 0,
    'title': 'First product',
    'price': 24.99
},
{
    'id': 1,
    'title': 'Second product',
    'price': 74.99
},
{
    'id': 2,
    'title': 'Third product',
    'price': 44.99
}
];

// funktio jolla haetaan tuote id:n perusteella
function getProductById(id) {
    for (let i = 0, length = products.length; i < length; i++) {
        if (products[i].id === id) {
            return products[i];
        }
    }
}
// middleware jossa kerrotaan että ollaan serverin juuressa
app.get('/', (req, res) => {
    res.send('Olet serverin juuressa. Ei täällä mitään ole.')
});

// middleware jolla haetaan kaikki tuotteet
app.get('/products', function(req, res) {
    res.json(products); // palvelin vastaa pyyntöön json-tiedostolla, jossa tuotteet
});

// middleware jolla haetaan tuote id:n perusteella
app.get('/products/:id', function(req, res) {
    // Huomaa tyypinmuunnos joka on pakko tehdä tässä tai ei toimi
    // Tällaisissa paikoissa Typescriptistä olisi apua
    let id = Number(req.params.id);
    res.json(getProductById(id)); // pyyntöön vastataan yhdellä json-muotoisella tuotteella
});

app.listen(3000, function() {
    console.log('Serveri portissa 3000!');
});
